#ifndef _land3D_h_ 
#define _land3D_h_ 

#include <QGLWidget> 

class Land3D : public QGLWidget //    Figure3D ,    QGLWidget
{ 

private: 
   GLuint m_nLand3D;  //  m_nFigure3D     ??
   GLdouble m_xRotate;   // ,      X
   GLdouble m_yRotate;   // ,      Y   
   GLdouble m_zRotate;  // ,      Z
   GLfloat m_Scale;     // ,    
   
   QPoint m_ptPosition; // ,       

//    QGLWidget   
protected:
   virtual void initializeGL();                    //    ,   OpenGL 
   virtual void resizeGL(int nWidth, int nHeight); //      
   virtual void paintGL();                         // ,     
   
   virtual void mousePressEvent(QMouseEvent* pe);  //         ()
   virtual void mouseMoveEvent(QMouseEvent* pe);   //         ()
   
   virtual void keyPressEvent(QKeyEvent* pe);      //          
           
   GLuint createLand3D(GLfloat fSize = 1.0f); //        ?? 


public: 
   Land3D(QWidget* pwgt = 0) ; // //  --   pwgt  QWidget (= 0 --  )
   GLfloat R_fun(GLint); //  -
   void C_fun(GLint x, GLfloat &color1, GLfloat &color2, GLfloat &color3); //  -
   void figure_rendering(int, int, float [][3][3]); //    
}; 

#endif //_land3D_h_ 